import { AdditionalParameters, ConnectionManager, Dispatch, FirstEmitCallback, SocketAndManagerReservedEvents, SocketEmitWrapperFunction, SocketEventListener, StoreType } from './SocketConnectionManager.types';
declare class SocketConnectionManager<CurrentState> {
    private socketsUrl;
    private debugMode;
    private additionalParameters;
    private setEmitQueueConstantParameters;
    private socketsConnected;
    private listeners;
    private listenersCallbacks;
    private dynamicListenersQueue;
    private dynamicListenersCallbacks;
    private socket;
    private getPushToEmitQueueFunction;
    private toEmit;
    private runAsFirstEmitOnConnect;
    private beforeConnectStarts;
    private managerAndSocketEventsActions;
    /**
     * This can be replaced with `setSocketEmitWrapper` in userland code
     */
    private socketEmitWrapper;
    private listenWithStore;
    private initialRequiredEmitsAck;
    private requiredEmitsAckLeft;
    private toEmitAfterRequiredEmitsAck;
    constructor(socketsUrl: string, debugMode?: boolean, additionalParameters?: AdditionalParameters, setEmitQueueConstantParameters?: (<T extends Record<string, unknown>>(argsRef: T, emitName: string, currentState: CurrentState) => void) | undefined);
    private isDebugMode;
    setEmitQueueConstantParametersFunction: (callback: <T extends Record<string, unknown>>(argsRef: T, emitName: string, currentState: CurrentState) => void) => void;
    closeConnection: (closeCallback?: () => void) => void;
    private ackRequiredEmit;
    private runFirstEmitFromQueue;
    private runAsFirstEmit;
    private addToEmitQueueWithStore;
    private createEmitQueue;
    private createListenWithStore;
    private bindManagerHandlers;
    private connectToSockets;
    setListeners: (listenersParam: SocketEventListener<CurrentState>[]) => void;
    addListener: (listener: SocketEventListener<CurrentState>, key: string) => void;
    removeListener: (key: string) => void;
    setFirstEmits: (emits: FirstEmitCallback<CurrentState>[]) => void;
    setBeforeConnectStarts: (callback: (dispatch?: Dispatch, store?: StoreType<CurrentState>) => void) => void;
    setManagerEventsActions: <T extends keyof import("./SocketConnectionManager.types").SocketReservedEvents<CurrentState> | keyof import("./SocketConnectionManager.types").ManagerReservedEventsHandlers<CurrentState>>(event: T, action: SocketAndManagerReservedEvents<CurrentState>[T]) => void;
    setSocketEmitWrapper: (socketEmitWrapperParam: SocketEmitWrapperFunction) => void;
    /**
     * Use to set events that are required to receive ack before emitting more events.
     * @param requiredEmitsAck Array of event names that are required to receive ack
     */
    setRequiredEmitsAck(requiredEmitsAck: string[]): void;
    connectionManager: () => ConnectionManager<CurrentState>;
}
export default SocketConnectionManager;
//# sourceMappingURL=SocketConnectionManager.d.ts.map